// This file was generated by gir (https://github.com/gtk-rs/gir)
// from
// from gir-files (https://github.com/gtk-rs/gir-files.git)
// DO NOT EDIT

use crate::PreferencesBin;
use glib::{
    prelude::*,
    signal::{connect_raw, SignalHandlerId},
    translate::*,
};
use std::{boxed::Box as Box_, fmt, mem::transmute};

glib::wrapper! {
    #[doc(alias = "DzlPreferencesEntry")]
    pub struct PreferencesEntry(Object<ffi::DzlPreferencesEntry, ffi::DzlPreferencesEntryClass>) @extends PreferencesBin, gtk::Bin, gtk::Container, gtk::Widget, @implements gtk::Buildable;

    match fn {
        type_ => || ffi::dzl_preferences_entry_get_type(),
    }
}

impl PreferencesEntry {
    pub const NONE: Option<&'static PreferencesEntry> = None;
}

mod sealed {
    pub trait Sealed {}
    impl<T: super::IsA<super::PreferencesEntry>> Sealed for T {}
}

pub trait PreferencesEntryExt: IsA<PreferencesEntry> + sealed::Sealed + 'static {
    #[doc(alias = "dzl_preferences_entry_get_entry_widget")]
    #[doc(alias = "get_entry_widget")]
    fn entry_widget(&self) -> Option<gtk::Widget> {
        unsafe {
            from_glib_none(ffi::dzl_preferences_entry_get_entry_widget(
                self.as_ref().to_glib_none().0,
            ))
        }
    }

    #[doc(alias = "dzl_preferences_entry_get_title_widget")]
    #[doc(alias = "get_title_widget")]
    fn title_widget(&self) -> Option<gtk::Widget> {
        unsafe {
            from_glib_none(ffi::dzl_preferences_entry_get_title_widget(
                self.as_ref().to_glib_none().0,
            ))
        }
    }

    fn text(&self) -> Option<glib::GString> {
        ObjectExt::property(self.as_ref(), "text")
    }

    fn set_text(&self, text: Option<&str>) {
        ObjectExt::set_property(self.as_ref(), "text", text)
    }

    fn title(&self) -> Option<glib::GString> {
        ObjectExt::property(self.as_ref(), "title")
    }

    fn set_title(&self, title: Option<&str>) {
        ObjectExt::set_property(self.as_ref(), "title", title)
    }

    #[doc(alias = "activate")]
    fn connect_activate<F: Fn(&Self) + 'static>(&self, f: F) -> SignalHandlerId {
        unsafe extern "C" fn activate_trampoline<P: IsA<PreferencesEntry>, F: Fn(&P) + 'static>(
            this: *mut ffi::DzlPreferencesEntry,
            f: glib::ffi::gpointer,
        ) {
            let f: &F = &*(f as *const F);
            f(PreferencesEntry::from_glib_borrow(this).unsafe_cast_ref())
        }
        unsafe {
            let f: Box_<F> = Box_::new(f);
            connect_raw(
                self.as_ptr() as *mut _,
                b"activate\0".as_ptr() as *const _,
                Some(transmute::<_, unsafe extern "C" fn()>(
                    activate_trampoline::<Self, F> as *const (),
                )),
                Box_::into_raw(f),
            )
        }
    }

    #[doc(alias = "changed")]
    fn connect_changed<F: Fn(&Self, &str) + 'static>(&self, f: F) -> SignalHandlerId {
        unsafe extern "C" fn changed_trampoline<
            P: IsA<PreferencesEntry>,
            F: Fn(&P, &str) + 'static,
        >(
            this: *mut ffi::DzlPreferencesEntry,
            object: *mut libc::c_char,
            f: glib::ffi::gpointer,
        ) {
            let f: &F = &*(f as *const F);
            f(
                PreferencesEntry::from_glib_borrow(this).unsafe_cast_ref(),
                &glib::GString::from_glib_borrow(object),
            )
        }
        unsafe {
            let f: Box_<F> = Box_::new(f);
            connect_raw(
                self.as_ptr() as *mut _,
                b"changed\0".as_ptr() as *const _,
                Some(transmute::<_, unsafe extern "C" fn()>(
                    changed_trampoline::<Self, F> as *const (),
                )),
                Box_::into_raw(f),
            )
        }
    }

    #[doc(alias = "text")]
    fn connect_text_notify<F: Fn(&Self) + 'static>(&self, f: F) -> SignalHandlerId {
        unsafe extern "C" fn notify_text_trampoline<
            P: IsA<PreferencesEntry>,
            F: Fn(&P) + 'static,
        >(
            this: *mut ffi::DzlPreferencesEntry,
            _param_spec: glib::ffi::gpointer,
            f: glib::ffi::gpointer,
        ) {
            let f: &F = &*(f as *const F);
            f(PreferencesEntry::from_glib_borrow(this).unsafe_cast_ref())
        }
        unsafe {
            let f: Box_<F> = Box_::new(f);
            connect_raw(
                self.as_ptr() as *mut _,
                b"notify::text\0".as_ptr() as *const _,
                Some(transmute::<_, unsafe extern "C" fn()>(
                    notify_text_trampoline::<Self, F> as *const (),
                )),
                Box_::into_raw(f),
            )
        }
    }

    #[doc(alias = "title")]
    fn connect_title_notify<F: Fn(&Self) + 'static>(&self, f: F) -> SignalHandlerId {
        unsafe extern "C" fn notify_title_trampoline<
            P: IsA<PreferencesEntry>,
            F: Fn(&P) + 'static,
        >(
            this: *mut ffi::DzlPreferencesEntry,
            _param_spec: glib::ffi::gpointer,
            f: glib::ffi::gpointer,
        ) {
            let f: &F = &*(f as *const F);
            f(PreferencesEntry::from_glib_borrow(this).unsafe_cast_ref())
        }
        unsafe {
            let f: Box_<F> = Box_::new(f);
            connect_raw(
                self.as_ptr() as *mut _,
                b"notify::title\0".as_ptr() as *const _,
                Some(transmute::<_, unsafe extern "C" fn()>(
                    notify_title_trampoline::<Self, F> as *const (),
                )),
                Box_::into_raw(f),
            )
        }
    }
}

impl<O: IsA<PreferencesEntry>> PreferencesEntryExt for O {}

impl fmt::Display for PreferencesEntry {
    fn fmt(&self, f: &mut fmt::Formatter) -> fmt::Result {
        f.write_str("PreferencesEntry")
    }
}
